name: hil
on:
  push:

permissions:
  contents: read
            
jobs:
  linux-tests:
    runs-on: ubuntu-latest
    env:
      TEST_RESULTS_PATH: "/tmp/test-results"
    strategy:
      matrix:
        go-version:
          - '1.14'
          - 'oldstable'
          - 'stable'
    steps:
      - uses: actions/checkout@c85c95e3d7251135ab7dc9ce3241c5835cc595a9 # v3.5.0

      - name: Make Test Directory
        run: mkdir -p "$TEST_RESULTS_PATH"/hil
      
      - name: Setup Go
        uses: actions/setup-go@4d34df0c2316fe8122ab82dc22947d607c0c91f9 # v4.0.0
        with:
          go-version: ${{ matrix.go-version }}

      - name: Install gotestsum
        uses: autero1/action-gotestsum@2e48af62f5248bd3b014f598cd1aa69a01dd36e3   # TSCCR: no entry for repository "autero1/action-gotestsum"
        with:
          gotestsum_version: 1.9.0

      - name: Run gotestsum
        env:
          PLATFORM: linux
          REPORT_FILE: ${{ env.TEST_RESULTS_PATH }}/hil/gotestsum-report.xml
        run: |-
          gotestsum --format=short-verbose --junitfile ${{ env.REPORT_FILE }} -- -p 2 ./...

      - name: Upload Test Results
        uses: actions/upload-artifact@0b7f8abb1508181956e8e162db84b466c27e18ce # v3.1.2
        with:
          path: ${{ env.TEST_RESULTS_PATH }}
          name: tests-linux
  
  windows-tests:
    runs-on: windows-latest
    env:
      TEST_RESULTS_PATH: 'c:\Users\runneradmin\AppData\Local\Temp\test-results'
    strategy:
      matrix:
        go-version:
          - '1.14'
          - 'oldstable'
          - 'stable'
    steps:
      - run: git config --global core.autocrlf false
      - uses: actions/checkout@c85c95e3d7251135ab7dc9ce3241c5835cc595a9 # v3.5.0

      - name: Setup Go
        uses: actions/setup-go@4d34df0c2316fe8122ab82dc22947d607c0c91f9 # v4.0.0
        with:
          go-version: ${{ matrix.go-version }}

      - name: Install gotestsum
        uses: autero1/action-gotestsum@2e48af62f5248bd3b014f598cd1aa69a01dd36e3   # TSCCR: no entry for repository "autero1/action-gotestsum"
        with:
          gotestsum_version: 1.9.0

      - name: Run gotestsum
        env:
          PLATFORM: windows
          REPORT_FILE: ${{ env.TEST_RESULTS_PATH }}/hil/gotestsum-report.xml
        run: |-
          gotestsum.exe --format=short-verbose --junitfile ${{ env.REPORT_FILE }} -- -p 2 ./...

      - name: Upload Test Results
        uses: actions/upload-artifact@0b7f8abb1508181956e8e162db84b466c27e18ce # v3.1.2
        with:
          path: ${{ env.TEST_RESULTS_PATH }}
